#include "stdafx.h"
#include "Send_client.h"
#include "Send_clientDlg.h"

DWORD Data_packets_received = 0;

BOOL Transfer_receive_data()
{
  if( DataReadyEvent ) {
    // Check packet ready event
    DWORD nEvent = WaitForSingleObject(DataReadyEvent, 0);
    if(nEvent == WAIT_OBJECT_0) {
      // The event is signaled - data is ready
      Data_packets_received++;
      // Reset data ready event (data is read)
      ResetEvent(DataReadyEvent);
      return TRUE;
    }
  }
  return FALSE;
}

//=================================================================================================
// Objects handles
//
HANDLE DataReadyEvent = NULL;
HANDLE hFileMapping   = NULL;
LPBYTE pMapBuff       = NULL;

BOOL Transfer_objects_create()
{
  DECLARE_MODULE_NAME;

  //----- Create data ready event -----------------------------------------------------------------
  // Manual reset event!
  DataReadyEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, TRANSFER_DATA_EVENT_NAME);
  if(DataReadyEvent == NULL) {
    MessageBox( NULL, " Cannot open data ready event ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  ResetEvent(DataReadyEvent); // Drop old data if any
  //----- Create memory file ----------------------------------------------------------------------
  hFileMapping = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, TRANSFER_DATA_FILE_NAME);
  if(hFileMapping == NULL) {
    MessageBox( NULL, " Cannot open memory file ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  // Get pointer to data buffer
  pMapBuff = (BYTE*)MapViewOfFile(hFileMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  if(pMapBuff == NULL) {
    MessageBox( NULL, " Cannot get memory file data buffer ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  //----- All work done successfully --------------------------------------------------------------
  return TRUE;
}

void Transfer_objects_destroy()
{
  if(pMapBuff) UnmapViewOfFile(pMapBuff); 
  SAFE_CLOSE_HANDLE(hFileMapping);
  SAFE_CLOSE_HANDLE(DataReadyEvent);
}
