#include "stdafx.h"
#include "Send_server.h"
#include "Send_serverDlg.h"

DWORD Data_for_transfer;  // Can be some structure
DWORD Data_packets_dropped = 0;

void Transfer_send_data()
{
  if( !DataReadyEvent ) {
    Data_packets_dropped++;
  }
  else {
    // Check packet ready event
    DWORD nEvent = WaitForSingleObject(DataReadyEvent, 0);
    if(nEvent == WAIT_OBJECT_0) {
      // The event is signaled (receiving process not read data)
      Data_packets_dropped++;
//    ResetEvent(DataReadyEvent);
    }
    else {
      // Set new data
      CopyMemory(pMapBuff, &Data_for_transfer, TRANSFER_DATA_SIZE);
      // Set packet ready event
      SetEvent(DataReadyEvent);
    }
  }
}

//=================================================================================================
// Objects handles
//
HANDLE DataReadyEvent = NULL;
HANDLE hFileMapping   = NULL;
LPBYTE pMapBuff       = NULL;

BOOL Transfer_objects_create()
{
  DECLARE_MODULE_NAME;

  //----- Create data ready event -------------------------------------------------------
  // Manual reset event!
  DataReadyEvent = CreateEvent(NULL, TRUE, FALSE, TRANSFER_DATA_EVENT_NAME);
  if(DataReadyEvent == NULL) {
    MessageBox( NULL, " Cannot create data ready event ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  //----- Create memory file ------------------------------------------------------------
  hFileMapping = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, TRANSFER_DATA_SIZE, TRANSFER_DATA_FILE_NAME);
  if(hFileMapping == NULL) {
    MessageBox( NULL, " Cannot create memory file ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  // Get pointer to data buffer
  pMapBuff = (BYTE*)MapViewOfFile(hFileMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  if(pMapBuff == NULL) {
    MessageBox( NULL, " Cannot get memory file data buffer ", module, MB_OK | MB_APPLMODAL | MB_TOPMOST); 
    return FALSE;
  }
  //----- All work done successfully ----------------------------------------------------
  return TRUE;
}

void Transfer_objects_destroy()
{
  if(pMapBuff) UnmapViewOfFile(pMapBuff); 
  SAFE_CLOSE_HANDLE(hFileMapping);
  SAFE_CLOSE_HANDLE(DataReadyEvent);
}
